#include <stdlib.h>  /* for declaration of random() */
#include <math.h>   /* for declaration of log() */

/* Simulate stochastic birth-death process with per-capita
 * birth rate phi and per-capita death rate mu
 */
void Cbirthdeath2(double *phiptr, double *muptr,int *sptr,
	       double *eventTimes, int *popVec)
{
  int i, s = sptr[0];
  double phi = phiptr[0], mu = muptr[0], birthProb, r;

  birthProb = phi/(phi+mu);
  eventTimes[0] = 0.0;
  popVec[0] = 100;
  for (i=0; i < s-1; i++) {
    /* generate a random value from exponential distribution
     * with mean 1/(popSize*(phi+mu)) */
    r = -log((random()+1.0)/(RAND_MAX+1.0))/(popVec[i]*(phi+mu));
    eventTimes[i+1] = eventTimes[i] + r;
    if (random()/(double)RAND_MAX < birthProb)
      popVec[i+1] = popVec[i] + 1;
    else
      popVec[i+1] = popVec[i] - 1;
  }
}
