#include <stdlib.h>  /* for declaration of random() */
#include <math.h>   /* for declaration of floor() */

/* Permute the elements of a vector using the Fisher-Yates shuffle */
void Cshuffle(double *v, int *nptr)
{
  int i, j, n = nptr[0];
  double tmpDbl;

  for (i=n; i > 1; i--) {
    /* Generate a random integer from 0 to i-1
     * (not from 1 to i, because vectors in C use 0-based indexing). */
    j = (int)floor(((double) random()) / (RAND_MAX + 1.0) * i);
    /* swap v[j] with the last element of v */
    tmpDbl = v[j];  v[j] = v[i-1];  v[i-1] = tmpDbl;
  }
}
