#include <R.h>   /* for declaration of random-number routines */
#include <math.h>   /* for declaration of floor() */

/* Permute the elements of a vector using the Fisher-Yates shuffle
 * using R's random number generator */
void Cshuffle2(double *v, int *nptr)
{
  int i, j, n = nptr[0];
  double tmpDbl;

  GetRNGstate();
  for (i=n; i > 1; i--) {
    /* Generate a random integer from 0 to i-1
     * (not from 1 to i, because vectors in C use 0-based indexing). */
    j = (int)floor(unif_rand() * i);
    /* swap v[j] with the last element of v */
    tmpDbl = v[j];  v[j] = v[i-1];  v[i-1] = tmpDbl;
  }
  PutRNGstate();
}
