function [eventTimes,popSizes] = birthdeath(phi,mu,numEvents,n0)
% birthdeath   Stochastic birth-death process with constant
% per capita rates
eventTimes = zeros(1,numEvents+1);
popSizes = zeros(1,numEvents+1);
eventTimes(1) = 0;  popSizes(1) = n0;
for i=1:numEvents
  if (popSizes(i) == 0)
    eventTimes((i+1):(numEvents+1)) = eventTimes(i);
    popSizes((i+1):(numEvents+1)) = 0;
    break;
  end
  eventTimes(i+1) = eventTimes(i)+interEventTime(phi,mu,popSizes(i));
  if (rand < probBirth(phi,mu))
    popSizes(i+1) = popSizes(i) + 1;
  else
    popSizes(i+1) = popSizes(i) - 1;
  end
end

% time between consecutive events
function retval = interEventTime(phi,mu,N)
totalRate = (phi+mu)*N;
retval = -log(rand)/totalRate;

% probability that the next event is a birth
function retval = probBirth(phi,mu)
retval = phi/(phi+mu);
