function retval = fib(steps,first,second)
% fib   Compute Fibonacci numbers
%
% FIB(STEPS,FIRST,SECOND)
%  STEPS: how many iterations to do -- if steps=k then compute the
%         (k+1)'st Fibonacci number
%  FIRST,SECOND: the first two numbers in the sequence
%                (default: 0 and 1, respectively)

% set up default parameters if necessary
if (nargin < 2)
  first = 0;
end
if (nargin < 3)
  second = 1;
end
for i = 1:steps
  nextval = first+second;  % compute next value
  first = second;  % update records
  second = nextval;
end
retval = second;
